


function LBP.CreateConfig(self)
	
	local anker = LBP:CreateFrame("frame", "LBPtabFrame", UIParent, nil, "TOP", UIParent, "CENTER", 0, 350, 220, 50)
	
	local tab = LBP:CreateFrame("frame", "LBPtabFrame", anker, nil, "TOP", anker, "TOP", 0, 0, 220, 50)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/BUTTONS/UI-SliderBar-Border", edgeSize = 4, insets = { left = 0, right = 0, top = 3, bottom = 2 } });
	
	--tab:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	
	--frame:Show()
	
	local hintergrund = LBP:CreateFrame("frame", "LBPtabFrame", tab, nil, "TOPLEFT", tab, "TOPLEFT", -40, 10, 600, 450)
	hintergrund:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	hintergrund:SetFrameLevel(tab:GetFrameLevel()-1);
	
	
	
	
	local alpha = 1
	
	local zonetext = GetZoneText();
	local subzonetext = GetSubZoneText();
	
	tab.zonetext = GetZoneText()
	tab.subzonetext = GetSubZoneText()
	tab.id = nil
	
	
	tinsert(UISpecialFrames,"LBPtabFrame");
	
	
	
	tab.textbox = LBP:CreateFontString(tab, "textbox","ARTWORK", "GameFontNormal", "CENTER", tab, "TOP", 0, -25, 220-24-24, 14*3, "CENTER", "MIDDLE", 1, 1, 1, 1)
	tab.textbox:SetText("Zonetext and Subzonetext")
	
	
	
	
	
	
	
	
	
	
	
	local edit_instanceID
	local edit_encounterID
	local edit_ID
	
	function anker.SetTemplate(self, instanceID, encounterID, id)
		edit_instanceID = instanceID;
		edit_encounterID = encounterID;
		edit_ID = id;
	end	
	
	
	
	
	local frame = LBP:CreateFrame("frame", "LBPConfigFrame", anker, nil, "TOPRIGHT", anker, "TOPLEFT", -40, 10, 300, 450)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:Show()
	--tinsert(UISpecialFrames,"LBPConfigFrame");
	
	
	frame.close = LBP.CreateCloseButton(self, frame, "Config_CloseButton", 24, "TOPRIGHT", frame, "TOPRIGHT", -1, -1)
	frame.close:SetScript("OnClick", 
		function(self) 
			--print("74")
			LBPMainFrame:Check()
			anker:Hide()
		end
	)
	
	
	
	
	
	
	
	
	frame.button = CreateFrame("BUTTON", "Button_CreateCard", frame, "UIPanelButtonTemplate")
	frame.button:SetText("Create Card")
	frame.button:SetWidth(80)
	frame.button:SetHeight(30)
	frame.button:SetScript("OnClick", 
		function(self) 
			if frame.createlist:IsVisible() then
				frame.createlist:Hide()
				else
				frame.createlist:tierlist()
				frame.createlist:Show()
			end
		end
	)
	
	frame.button:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -10, 10)
	
	
	
	
	frame.createlist = LBP:CreateFrame("frame", "LBPConfigFrame", frame.button, nil, "TOPLEFT", frame.button, "TOPRIGHT", 0, 0, 200, 200)
	frame.createlist:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame.createlist:Hide()
	frame.createlist:SetFrameStrata("TOOLTIP")
	
	
	
	frame.createlist.DB = {}
	
	ToggleEncounterJournal()
	ToggleEncounterJournal()
	
	
	for a = EJ_GetNumTiers(),4,-1 do
		EJ_SelectTier(a)
		
		local name = EJ_GetTierInfo(a)
		
		
		frame.createlist.DB[a] = {}
		frame.createlist.DB[a]["Name"] = name;
		--print(name)
		
		
		local index = 1 
		while EJ_GetInstanceByIndex(index, true) do
			local instanceID, name = EJ_GetInstanceByIndex(index, true) 
			
			EJ_SelectInstance(instanceID)
			
			frame.createlist.DB[a][instanceID] = {}
			frame.createlist.DB[a][instanceID]["Name"] = name
			
			local index2 = 1 
			while EJ_GetEncounterInfoByIndex(index2, instanceID) do 
				local name = EJ_GetEncounterInfoByIndex(index2, instanceID)
				-- print("   "..name)
				index2 = index2+1
				frame.createlist.DB[a][instanceID][index2] = name
			end
			
			index = index+1
		end
	end	
	
	
	function frame.createlist.tierlist( self )
		
		local kids = { frame.createlist:GetChildren() };
		for _, child in ipairs(kids) do
			child:Hide()
		end
		
		frame.createlist:SetHeight(20)
		
		local tmpframe= LBP:CreateFrame("frame", "LBPConfigFrame", frame.createlist, nil, "TOPLEFT", frame.createlist, "TOPLEFT", 10, -10, 1, 1)
		
		for a = EJ_GetNumTiers(),4,-1 do
			tmpframe = LBP:CreateFrame("frame", "test", frame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
			tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
			tmpframe.text:SetText(frame.createlist.DB[a]["Name"])
			tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..frame.createlist.DB[a]["Name"].."|r") end)
			tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..frame.createlist.DB[a]["Name"].."|r") end)
			tmpframe:SetScript("OnMouseUp", function(self) frame.createlist.raidlist(self,  a) end)
			
			frame.createlist:SetHeight(frame.createlist:GetHeight()+20)
		end
	end
	
	
	function frame.createlist.raidlist( self, number )
		
		local kids = { frame.createlist:GetChildren() };
		for _, child in ipairs(kids) do
			child:Hide()
		end
		
		frame.createlist:SetHeight(20)
		
		local tmpframe= LBP:CreateFrame("frame", "LBPConfigFrame", frame.createlist, nil, "TOPLEFT", frame.createlist, "TOPLEFT", 10, -10, 1, 1)
		
		for b=1000,1,-1 do
			if frame.createlist.DB[number][b] then
				tmpframe = LBP:CreateFrame("frame", "test", frame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
				tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
				tmpframe.text:SetText(frame.createlist.DB[number][b]["Name"])
				tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..frame.createlist.DB[number][b]["Name"].."|r") end)
				tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..frame.createlist.DB[number][b]["Name"].."|r") end)
				tmpframe:SetScript("OnMouseUp", function(self) frame.createlist.encounterlist(self, b) end)
				
				frame.createlist:SetHeight(frame.createlist:GetHeight()+20)
			end	
		end		
		
	end
	
	function frame.createlist.encounterlist( self, instanceID )
		
		local kids = { frame.createlist:GetChildren() };
		for _, child in ipairs(kids) do
			child:Hide()
		end
		
		frame.createlist:SetHeight(20)
		
		local tmpframe= LBP:CreateFrame("frame", "LBPConfigFrame", frame.createlist, nil, "TOPLEFT", frame.createlist, "TOPLEFT", 10, -10, 1, 1)
		
		local index = 1 
		
		while EJ_GetEncounterInfoByIndex(index, instanceID) do 
			local name, _, encounterID = EJ_GetEncounterInfoByIndex(index, instanceID)
			
			tmpframe = LBP:CreateFrame("frame", "test", frame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
			tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
			tmpframe.text:SetText(name)
			tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..name.."|r") end)
			tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..name.."|r") end)
			tmpframe:SetScript("OnMouseUp", function(self) 
				
				
				
				local specid, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
				card = {};
				card["Name"] = name;
				
				card["Talents"] = LBP:GetTalentString();
				card["Spec"] = specid;
				card["Glyphs"] = {
					["1"] = {},
					["2"] = {}
				};
				for index,value in pairs(LBP:GetGlyphTable()) do
					if value[2] and value[3] then
						card["Glyphs"][tostring(value[1])][value[2]] = value[3];
					end
				end
				card["Macro1"] = "/script print(\"LBP Macro #1\")";
				card["Macro2"] = "/script print(\"LBP Macro #2\")";
				card["Macro3"] = "/script print(\"LBP Macro #3\")";
				card["Macro4"] = "/script print(\"LBP Macro #4\")";
				
				local id = time()
				
				if not LBP_DB[instanceID] then LBP_DB[instanceID] = {} end
				if not LBP_DB[instanceID][encounterID] then 
					LBP_DB[instanceID][encounterID] = {} 
					card["active"] = true
				end
				
				
				
				
				while LBP_DB[instanceID][encounterID][id] do
					id = id-1;
				end
				
				LBP_DB[instanceID][encounterID][id] = card;
				
				edit_instanceID = instanceID;
				edit_encounterID = encounterID;
				edit_ID = id;
				
				
				anker:Build()	
				
				frame.createlist:Hide()
				
				
				
				
			end)						
			
			frame.createlist:SetHeight(frame.createlist:GetHeight()+20)
			index = index+1
		end
		
	end	
	
	
	
	
	
	
	
	
	
	
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", frame, "TOP", 0, -10, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
	
	
	textbox:SetText("Config")
	
	
	
	
	
	
	local speclist_rahmen = LBP:CreateFrame("frame", "speclist_rahmen", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 100, 10)
	speclist_rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	local speclist = {}
	
	for a=1,4 do
		local specid, specname, description, icon, background, role = GetSpecializationInfo(a);
		
		if specid then
			speclist[a] = LBP:CreateFrame("frame", "speclist", speclist_rahmen, nil, "TOPLEFT", speclist_rahmen, "TOPLEFT", 0, -(a-1)*36-8, 200, 36)
			--speclist[a].icon = LBP:CreateFrame("frame", "speclist_icon", speclist[a], nil, "LEFT", speclist[a], "LEFT", 10, 0, 32, 32)
			--				speclist[a].icon:SetBackdrop({bgFile = icon });
			
			
			speclist[a].icon = speclist[a]:CreateTexture("speclist_icon"..a)
			speclist[a].icon:SetTexture(icon)
			speclist[a].icon:SetPoint("TOPLEFT",speclist[a],"LEFT", 10, 16 )
			speclist[a].icon:SetPoint("BOTTOMRIGHT",speclist[a],"LEFT", 42, -16 )
			speclist[a].icon:SetDesaturated(true)
			
			
			speclist[a].text = LBP:CreateFontString(speclist[a], "textbox","ARTWORK", "GameFontNormal", "LEFT", speclist[a].icon, "RIGHT", 10, 0, 300, 20, "LEFT", "MIDDLE", 1, 1, 1, 1)
			speclist[a].text:SetText(specname)
			speclist[a].text:SetWidth( speclist[a].text:GetStringWidth() )
			speclist_rahmen:SetWidth( math.max(speclist_rahmen:GetWidth(), speclist[a].text:GetWidth() + 10 +32 +10 +10))
			speclist_rahmen:SetHeight(a*36+16)
			
			speclist[a]:SetScript("OnEnter", function(self) speclist[a].text:SetText("|c00FFD100"..specname.."|r") speclist[a].icon:SetDesaturated(false) end)
			speclist[a]:SetScript("OnLeave", function(self) speclist[a].text:SetText("|c00FFFFFF"..specname.."|r") speclist[a].icon:SetDesaturated(true) end)
			
			speclist[a]:SetScript("OnMouseUp", function(self) speclist_rahmen:Hide() LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Spec"] = specid anker:Build() end)
			--speclist[a]:SetScript("OnMouseUp", function(self) speclist_rahmen:Hide() print(edit_encounterID) frame:Build() end)
			
		end
	end
	speclist_rahmen:SetScript("OnMouseUp", function(self)
		self:Hide()
	end)
	tinsert(UISpecialFrames,"speclist_rahmen");
	
	speclist_rahmen:SetFrameStrata("TOOLTIP")
	speclist_rahmen:Hide()
	
	
	
	
	
	local list = LBP:CreateFrame("frame", "Liste", frame, nil, "TOP", textbox, "BOTTOM", 0, 0, 1, 1)
	
	
	
	
	
	
	
	
	local list_tab = LBP:CreateFrame("ScrollFrame", "List_Scroll", frame, "UIPanelScrollFrameTemplate", "TOPLEFT", frame, "TOPLEFT", 10, -30, 260, 430-50)
	list_tab:SetScrollChild(list)
	
	
	
	
	--  Ende List
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	frame.button_togglezones = CreateFrame("BUTTON", "Button_togglezones", frame, "UIPanelButtonTemplate")
	frame.button_togglezones:SetWidth(120)
	frame.button_togglezones:SetHeight(20)
	
	frame.button_togglezones:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 10, 10)
	frame.button_togglezones:Hide()
	frame.showzones = false;
	
	
	local glyphlist_rahmen = LBP:CreateFrame("frame", "glyphlist_rahmen", frame, nil, "TOPLEFT", frame, "TOPRIGHT", 0, 0, 200, 300)
	glyphlist_rahmen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	tinsert(UISpecialFrames,"glyphlist_rahmen");
	--local glyphlist_tab = LBP:CreateFrame("ScrollFrame", "Glyphlist_Scroll", glyphlist_rahmen, "UIPanelScrollFrameTemplate", "TOPLEFT", glyphlist_rahmen, "TOPLEFT", 10, -10, 200-20-20, 280)
	
	local glyphlist = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist_rahmen, nil, "TOPLEFT", glyphlist_rahmen, "TOPLEFT", 10, -10, 1, 1)
	
	glyphlist.list = {}
	local n = 3;
	
	glyphlist.list[1] = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
	glyphlist.list[1].icon = glyphlist.list[1]:CreateTexture("glyphlist_icon")
	glyphlist.list[1].icon:SetTexture("Interface/BUTTONS/UI-EmptySlot")
	glyphlist.list[1].icon:SetTexture("Interface/PaperDoll/UI-Backpack-EmptySlot")
	glyphlist.list[1].icon:SetPoint("TOPLEFT",glyphlist.list[1],"LEFT", 0, 16 )
	glyphlist.list[1].icon:SetPoint("BOTTOMRIGHT",glyphlist.list[1],"LEFT", 32, -16 )
	--tmpframe.icon:SetTexCoord(0.25, 0.75, 0.25, 0.75)
	glyphlist.list[1].icon:SetDesaturated(true)
	
	--tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
	--tmpframe.icon:SetBackdrop({bgFile =  "Interface/ICONS/INV_MISC_QUESTIONMARK"});
	glyphlist.list[1].tb_name =  LBP:CreateFontString(glyphlist.list[1], "textbox","ARTWORK", "GameFontNormal", "LEFT", glyphlist.list[1], "LEFT", 42, 0, 140, 32, "LEFT", "MIDDLE", 1, 1, 1, 1)
	glyphlist.list[1].tb_name:SetText(L["no Glyph selected"])
	glyphlist.list[1]:SetScript("OnEnter", function(self) glyphlist.list[1].tb_name:SetText("|c00FFD100".. L["no Glyph selected"].. "|r") glyphlist.list[1].icon:SetDesaturated(false) end)
	glyphlist.list[1]:SetScript("OnLeave", function(self) glyphlist.list[1].tb_name:SetText("|c00FFFFFF".. L["no Glyph selected"].. "|r") glyphlist.list[1].icon:SetDesaturated(true) end)
	
	glyphlist.list[1].type = 1;
	glyphlist.list[1]:Hide()
	
	glyphlist.list[2] = LBP:CreateFrame("frame", "LBPGlyphlist2", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
	glyphlist.list[2].icon = glyphlist.list[2]:CreateTexture("glyphlist_icon")
	glyphlist.list[2].icon:SetTexture("Interface/PaperDoll/UI-Backpack-EmptySlot")
	glyphlist.list[2].icon:SetPoint("TOPLEFT",glyphlist.list[2],"LEFT", 0, 16 )
	glyphlist.list[2].icon:SetPoint("BOTTOMRIGHT",glyphlist.list[2],"LEFT", 32, -16 )
	--glyphlist.list[2].icon:SetTexCoord(0.25, 0.75, 0.25, 0.75)
	glyphlist.list[2].icon:SetDesaturated(true)
	--glyphlist.list[2].icon = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist.list[2], nil, "TOPLEFT", glyphlist.list[2], "TOPLEFT", 0, 0, 32, 32)
	--glyphlist.list[2].icon:SetBackdrop({bgFile =  "Interface/ICONS/INV_MISC_QUESTIONMARK"});
	glyphlist.list[2].tb_name =  LBP:CreateFontString(glyphlist.list[2], "textbox2","ARTWORK", "GameFontNormal", "LEFT", glyphlist.list[2], "LEFT", 42, 0, 140, 32, "LEFT", "MIDDLE", 1, 1, 1, 1)
	glyphlist.list[2].tb_name:SetText(L["no Glyph selected"])
	glyphlist.list[2]:SetScript("OnEnter", function(self) glyphlist.list[2].tb_name:SetText("|c00FFD100".. L["no Glyph selected"] .."|r") glyphlist.list[2].icon:SetDesaturated(false) end)
	glyphlist.list[2]:SetScript("OnLeave", function(self) glyphlist.list[2].tb_name:SetText("|c00FFFFFF".. L["no Glyph selected"] .."|r") glyphlist.list[2].icon:SetDesaturated(true) end)
	
	--glyphlist.list[2]:SetScript("OnEnter", function(self) print("OnEnter") glyphlist.list[2].icon:SetDesaturated(false) end)
	--glyphlist.list[2]:SetScript("OnLeave", function(self) print("OnLeave") glyphlist.list[2].icon:SetDesaturated(true) end)
	glyphlist.list[2].type = 2;
	glyphlist.list[2]:Hide()
	
	
	
	for a=1,GetNumGlyphs() do 
		local name, glyphType, isKnown, icon, castSpell,link, subText = GetGlyphInfo(a)
		
		if icon then 
			
			local tmpframe = LBP:CreateFrame("frame", "LBPGlyphlist", glyphlist, nil, "TOPLEFT", glyphlist, "TOPLEFT", 0, 0, 200, 32)
			--CreateTexture("speclist_icon"..a)
			--speclist[a].icon:SetTexture(icon)
			--:SetPoint("TOPLEFT",speclist[a],"LEFT", 10, 16 )
			--speclist[a].icon:SetPoint("BOTTOMRIGHT",speclist[a],"LEFT", 42, -16 )
			--tmpframe.icon = LBP:CreateFrame("frame", "LBPGlyphlist", tmpframe, nil, "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 32, 32)
			--tmpframe.icon:SetBackdrop({bgFile = icon});
			tmpframe.icon = tmpframe:CreateTexture("glyphlist_icon"..a)
			tmpframe.icon:SetTexture(icon)
			tmpframe.icon:SetPoint("TOPLEFT",tmpframe,"LEFT", 0, 16 )
			tmpframe.icon:SetPoint("BOTTOMRIGHT",tmpframe,"LEFT", 32, -16 )
			tmpframe.icon:SetDesaturated(true)
			
			tmpframe.tb_name =  LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "LEFT", tmpframe, "LEFT", 42, 0, 140, 32, "LEFT", "MIDDLE", 1, 1, 1, 1)
			tmpframe.tb_name:SetText(name)
			
			tmpframe:SetScript("OnEnter", function(self) tmpframe.tb_name:SetText("|c00FFD100"..name.."|r") tmpframe.icon:SetDesaturated(false) end)
			tmpframe:SetScript("OnLeave", function(self) tmpframe.tb_name:SetText("|c00FFFFFF"..name.."|r") tmpframe.icon:SetDesaturated(true) end)
			
			tmpframe.type = glyphType;
			tmpframe.id = castSpell;
			tmpframe:Hide()
			
			glyphlist.list[n] = tmpframe;
			n=n+1; 	
		end 
		
	end
	
	
	--glyphlist:SetSize(250,32)
	--glyphlist_tab:SetScrollChild(glyphlist)
	
	
	function glyphlist_rahmen:Build(icon, glyph_type)
		local n = 0;
		local z = 15;
		
		for index, value in pairs(glyphlist.list) do
			value:Hide()
			if value.type == glyph_type then 
				value:Show()
				n=n+1;
			end
			for icon in pairs(LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Glyphs"][tostring(glyph_type)]) do
				if value.icon:GetTexture() == icon then
					value:Hide()
					n = n-1;
				end
			end
		end
		
		z = ceil(n/ceil(n/z));
		n = 0;
		
		for index, value in pairs(glyphlist.list) do
			if value:IsShown() then
				value:ClearAllPoints()
				value:SetPoint("TOPLEFT", glyphlist, "TOPLEFT", floor(n/z)*200,-mod(n,z)*32)
				value:SetScript("OnMouseUp", 
					function(self) 
						LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Glyphs"][tostring(glyph_type)][icon] = nil;
						LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Glyphs"][tostring(glyph_type)][value.icon:GetTexture()] = value.id;
						glyphlist_rahmen:Hide()
						anker:Build()
					end
				)				
				
				n=n+1;
			end
		end
		
		
		
		glyphlist_rahmen:SetSize(40+200*ceil(n/z), 32*min(z,n)+20)
	end
	
	function glyphlist_rahmen:Toggle()
		if glyphlist_rahmen:IsVisible() then
			glyphlist_rahmen:Hide()
			else
			glyphlist_rahmen:Show()
		end
	end
	
	glyphlist_rahmen:SetFrameStrata("TOOLTIP")
	glyphlist_rahmen:Hide()
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	--	local card = deepcopy(LBP_DB[zone][subzone][id]);
	
	local editcard = LBP:CreateFrame("frame", "LBPMainFrame", tab, nil, "TOP", tab, "TOP", 0, -50+6, 270, 270)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--editcard:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--editcard:SetBackdrop({bgFile = "Interface/BUTTONS/WHITE8X8", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--editcard:SetBackdropColor(0, 0, 0 , 1)
	
	
	
	
	editcard.SpecIcon_frame = LBP:CreateFrame("frame", "Templatecard_SpecIcon", editcard, nil, "TOPLEFT", editcard, "TOPLEFT", 10, -10, 32, 32)
	
	editcard.SpecIcon = editcard.SpecIcon_frame:CreateTexture("SpecIcon")
	editcard.SpecIcon:SetTexture("Interface/ICONS/INV_MISC_QUESTIONMARK");
	editcard.SpecIcon:SetAllPoints()
	
	
	editcard.SpecIcon_frame:SetScript("OnMouseUp", 
		function(self)
			if speclist_rahmen:IsVisible() then
				speclist_rahmen:Hide()
				else
				speclist_rahmen:ClearAllPoints()
				speclist_rahmen:SetPoint("TOP", editcard.SpecIcon_frame, "BOTTOM")
				speclist_rahmen:Show()
			end
		end
	)
	
	
	--	editcard.tb_name = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOPLEFT", 10, -15, 50, 20, "LEFT", "TOP", 1, 1, 1, 1)
	--		editcard.tb_name:SetText("Name:")
	
	editcard.editname = LBP:CreateFrame("EditBox", "editcard_editname", editcard, "InputBoxTemplate", "TOPLEFT", editcard.SpecIcon, "TOPRIGHT", 6, 0, 200, 18)
	editcard.editname:SetAutoFocus(false) 
	editcard.editname:SetJustifyH("LEFT");
	
	
	editcard.TemplateSpec = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)
	
	--frame:Show()
	
	
	
	
	editcard.tb_zone = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_name, "BOTTOMLEFT", 0, -15, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	editcard.tb_subzone = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.tb_zone, "BOTTOMLEFT", 0, -5, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	editcard.tb_specframe = LBP:CreateFrame("frame", "editcard_specname", editcard, nil, "TOPLEFT", editcard.editname, "BOTTOMLEFT", 0, -5, 200, 20)
	editcard.tb_spec = LBP:CreateFontString(editcard, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", editcard.editname, "BOTTOMLEFT", 0, -5, 300, 20, "LEFT", "TOP", 1, 1, 1, 1)
	
	editcard.tb_specframe:SetScript("OnMouseUp", 
		function(self)
			if speclist_rahmen:IsVisible() then
				speclist_rahmen:Hide()
				else
				speclist_rahmen:ClearAllPoints()
				speclist_rahmen:SetPoint("TOP", editcard.tb_specframe, "BOTTOM")
				speclist_rahmen:Show()
			end
		end
	)
	
	
	
	
	
	
	
	editcard.Talents = {};
	local classDisplayName, class, classID = UnitClass("player");
	local c;
	for a = 1,7 do
	for b = 1,3 do
		local _, _, iconTexture = GetTalentInfo(a,b,GetActiveSpecGroup())
		
		c = (a-1)*3+b;
		local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..c, editcard, nil, "CENTER", editcard, "TOPLEFT", (b-1)*32+26, -(a-1)*32-40-32,  32, 32)
		--local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..a, editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", mod(a-1,3)*32-120, -ceil(a/3)*32,  32, 32)
		
		tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..c)
		tmpframe.texture:SetTexture(iconTexture)
		tmpframe.texture:SetAllPoints()
		
		editcard.Talents[c] = tmpframe;
		editcard.Talents[c]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Talents[a]); GameTooltip:SetTalent(a, 1, nil, nil, classID); GameTooltip:Show(); end)
		editcard.Talents[c]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
	end
	end
	
	local glyphposition = {
		["x"] = {24+4, 0, -24-4, -20-4, 0, 20+4},
		["y"] = {2, 10, 2, -2, -16, -2},
		["point"] = {"BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT", "TOPRIGHT", "TOP", "TOPLEFT" },
		["length"] = {40,48,40,48,40,48},
	}
	
	editcard.Glyph = {};
	
	
	
	for a=1,6 do
		--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, "LEFT", frame, "RIGHT", -64+floor((a-1)/2)*64, -64*mod(a,2), 64-16*mod(a,2), 64-16*mod(a,2))
		local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, editcard, nil, "CENTER", editcard, "TOP", mod(a,2)*50+35, -math.floor((a-1)/2)*48-80, 48-12*mod(a,2), 48-12*mod(a,2))
		--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, editcard, nil, "CENTER", editcard, "TOP", 0+math.floor((a-1)/2)*50, -80-mod(a,2)*45, 48-12*mod(a,2), 48-12*mod(a,2))
		--local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, editcard, nil, glyphposition["point"][a], editcard, "TOPRIGHT", glyphposition["x"][a]-80, glyphposition["y"][a]-40-32+16-48-10, glyphposition["length"][a], glyphposition["length"][a])
		
		tmpframe.texture = tmpframe:CreateTexture("LBPGlyph"..a)
		tmpframe.texture:SetAllPoints()
		
		
		function tmpframe:SetGlyph(iconTexture, set)
			tmpframe.texture:SetTexture(iconTexture)
			if set then
				tmpframe:SetBackdropColor(1,1,1,1);
				else
				tmpframe:SetBackdropColor(1,0.2,0.2,1);
			end
		end
		editcard.Glyph[a] = tmpframe;
	end
	
	editcard.button2 = CreateFrame("BUTTON", "SetThisNTC", editcard, "UIPanelButtonTemplate")
	
	editcard.button2:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.button2, "ANCHOR_TOPLEFT"); GameTooltip:SetText("Set template's talentes, glyphs and zone to current ones"); GameTooltip:Show(); end)
	editcard.button2:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
	
	editcard.button2:SetText("Update")
	editcard.button2:SetWidth(180)
	editcard.button2:SetHeight(30)
	editcard.button2:SetScript("OnClick", 
		function(self) 
			local specid = GetSpecializationInfo(GetSpecialization());
			if not LBP_DB[edit_instanceID] then LBP_DB[edit_instanceID] = {}; end -- that should not happen
			if not LBP_DB[edit_instanceID][edit_encounterID] then LBP_DB[edit_instanceID][edit_encounterID] = {}; end -- that should not happen
			--LBP_DB[zone][subzone][id] = {};
			LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Talents"] = LBP:GetTalentString();
			LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Spec"] = specid;
			LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Glyphs"] = {["1"] = {}, ["2"] = {}, };
			for index,value in pairs(LBP:GetGlyphTable()) do
				LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Glyphs"][tostring(value[1])][value[2]] = value[3];
			end
			anker:Build()
		end
	)
	editcard.button2:SetPoint('TOP', tab, 'BOTTOM', 0, -300)
	
	editcard.button3 = CreateFrame("BUTTON", "RemoveNTC", editcard, "UIPanelButtonTemplate")
	
	editcard.button3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.button3, "ANCHOR_TOPLEFT"); GameTooltip:SetText("Remove this template"); GameTooltip:Show(); end)
	editcard.button3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
	
	editcard.button3:SetText("Remove")
	editcard.button3:SetWidth(180)
	editcard.button3:SetHeight(30)
	editcard.button3:SetScript("OnClick", 
		function(self) 
			if LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["active"] then
				LBP_DB[edit_instanceID][edit_encounterID][edit_ID] = nil;
				for index in pairs(LBP_DB[edit_instanceID][edit_encounterID]) do
					LBP_DB[edit_instanceID][edit_encounterID][index]["active"] = true
					break
				end
				else
				LBP_DB[edit_instanceID][edit_encounterID][edit_ID] = nil;
			end
			
			local n = 0;
			for index in pairs(LBP_DB[edit_instanceID][edit_encounterID]) do
				n=n+1;
			end
			if n == 0 then LBP_DB[edit_instanceID][edit_encounterID] = nil; end
			
			n = 0;
			for index in pairs(LBP_DB[edit_instanceID]) do
				n=n+1;
			end
			if n == 0 then LBP_DB[edit_instanceID] = nil; end
			
			edit_instanceID = nil;
			edit_encounterID = nil;
			edit_ID = nil;
			anker:Build()	
		end
	)
	editcard.button3:SetPoint('TOP', editcard.button2, 'BOTTOM', 0, -8)
	
	
	
	
	
	
	editcard.macroframe = {}
	for a = 1,4 do
		editcard.macroframe[a] = LBP:CreateFrame("frame", "Macroframe"..a, editcard, nil, "TOPRIGHT", editcard, "TOPRIGHT", -10+(a-4)*36, -232+16, 32, 32);
		--editcard.macroframe[a] = LBP:CreateFrame("frame", "Macroframe"..a, editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", -24-4-48-8+(a-1)*28*2, -250, 48, 48);
		--editcard.macroframe2 = LBP:CreateFrame("frame", "Macroframe2", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", -24-4, -250, 48, 48);
		--editcard.macroframe3 = LBP:CreateFrame("frame", "Macroframe3", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", 24+4, -250, 48, 48);
		--editcard.macroframe4 = LBP:CreateFrame("frame", "Macroframe4", editcard, nil, "CENTER", editcard.tb_spec, "BOTTOM", 24+4+48+8, -250, 48, 48);
	end
	
	
	
	function CreateEditBox(self, name, parent, width, height)
		
		
		local scrollframe = LBP:CreateFrame("ScrollFrame", "ScrollFrame_"..name, parent, "UIPanelScrollFrameTemplate", "TOPLEFT", parent, "TOPLEFT", 0, 0, width, height)
		scrollframe.name = "Scrollframe";
		
		local scrollchild = CreateFrame("EditBox", "LBPEditBox_"..name, scrollframe) --, "InputBoxTemplate")
		scrollchild:SetPoint("TOPLEFT", scrollframe, "TOPLEFT", 8,-6)
		scrollchild:SetPoint("BOTTOMRIGHT", scrollframe, "BOTTOMRIGHT", -8,6)
		
		scrollchild:SetScript("OnEscapePressed", function(self) EditBox_ClearFocus(self) end)
		scrollchild:SetScript("OnEditFocusLost", function(self) EditBox_ClearHighlight(self); end)
		scrollchild:SetScript("OnEditFocusGained", function(self) EditBox_HighlightText(self); end)
		scrollchild:SetFont("Fonts\\ARIALN.TTF",14,"none")
		scrollchild:SetMultiLine(true)
		scrollchild:SetAutoFocus(false) 
		scrollchild:SetMaxLetters(255);
		scrollchild:SetCursorPosition(0)
		scrollchild:SetScript("OnCursorChanged", 
			function(self, x, y, w, h) 
				local d = -y-scrollframe:GetVerticalScroll()
				if d>floor(height/13.99)*13.99 or d<0 then 
					scrollframe:SetVerticalScroll(math.max(scrollframe:GetVerticalScroll()+13.99*d/abs(d),0)) 
					scrollframe:UpdateScrollChildRect()
				end 
			end
		)
		
		scrollframe:SetSize(width, height)--80-8-8)
		scrollchild:SetSize(width, height)
		scrollframe:SetScrollChild(scrollchild)
		
		--scrollframe:Hide()
		
		return scrollframe, scrollchild
	end
	
	
	--local macrocard = LBP:CreateFrame("frame", "editcard", tab, nil, "TOPLEFT", tab, "TOPRIGHT", 40, 0, 300, 500)		
	--	macrocard:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	
	
	
	editcard.tb_macro = {}
	editcard.button_m = {}
	editcard.rahmen_macro = {}
	
	editcard.editbox_macro = {}
	editcard.editbox_macro_editbox = {}
	for a = 1,4 do
		editcard.tb_macro[a] = LBP:CreateFontString(editcard, "tb_Macro"..a, "ARTWORK", "GameFontNormal", "TOPLEFT", editcard, "TOPLEFT", 295, 45-(a-1)*110, 200, 20, "LEFT", "BOTTOM", 1, 1, 1, 1)
		editcard.tb_macro[a]:SetText("Macro "..a)
		
		
		
		editcard.rahmen_macro[a] = LBP:CreateFrame("frame", "Rahmen Macro"..a, editcard, nil, "TOPLEFT", editcard.tb_macro[a], "BOTTOMLEFT", 0, 0, 280, 80)
		editcard.rahmen_macro[a]:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
		
		editcard.editbox_macro[a], editcard.editbox_macro_editbox[a] = CreateEditBox(self, "macro"..a, editcard.rahmen_macro[a], 280-30-8, 80-8-8)
		editcard.editbox_macro[a]:SetPoint("TOPLEFT", editcard.rahmen_macro[a], "TOPLEFT", 10,-8)
		
		
		editcard.button_m[a] = CreateFrame("BUTTON", "CopyNTC", editcard, "UIPanelButtonTemplate")
		editcard.button_m[a]:SetText("Reset")
		editcard.button_m[a]:SetWidth(50)
		editcard.button_m[a]:SetHeight(20)
		editcard.button_m[a]:SetPoint("BOTTOMRIGHT", editcard.editbox_macro[a], "TOPRIGHT", 28, 5)		
		
		
		
	end
	
	
	
	local list_entries = {}		
	
	local textbox
	local tmpframe
	
	function anker:Build()
		
		list:SetHeight(1)
		
		textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 1, "LEFT", "TOP", 1, 1, 1, 1)
		tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 1)
		
		
		list:SetHeight(list:GetHeight()+textbox:GetHeight())
		
		-- build new ones
		for instanceID in pairs(LBP_DB) do
			if tonumber(instanceID) then
				
				zone = EJ_GetInstanceInfo(instanceID)
				
				if not list_entries["i"..instanceID] then
					list_entries["i"..instanceID] = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 15, "LEFT", "CENTER", 1, 1, 1, 1)
					list_entries["i"..instanceID]:SetText("|c00aaaaaa"..zone.."|r")
				end
				--list_entries[zone]:Hide()
				
				for encounterID in pairs(LBP_DB[instanceID]) do
					subzone = EJ_GetEncounterInfo(encounterID)
					
					if not list_entries["e"..encounterID] then
						list_entries["e"..encounterID] = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", list, "TOPLEFT", 10, 0, 280, 15, "LEFT", "BOTTOM", 1, 1, 1, 1)
						list_entries["e"..encounterID]:SetText("|c00aaaaaa"..subzone.."|r")			
					end
					
					for id, listcard in pairs(LBP_DB[instanceID][encounterID]) do
						if not list_entries[id] then
							list_entries[id] = LBP:CreateFrame("frame", "test", list, nil, "TOPLEFT", list, "TOPLEFT", 0, 0, 280, 25)
							list_entries[id].text = LBP:CreateFontString(list_entries[id], "textbox","ARTWORK", "GameFontNormalLarge", "TOP", list_entries[id], "TOP", 20, 0, 280, 25, "LEFT", "CENTER", 1, 1, 1, 1)
							-- list_entries[id].text:SetText("|c00ffffff" .. EJ_GetEncounterInfo(encounterID) .."|r")
							list_entries[id].text:SetText("|c00ffffff" .. LBP_DB[instanceID][encounterID][id]["Name"] .."|r")
							
							
							-- list_entries[id]:SetScript("OnEnter", function(self) list_entries[id].text:SetText("|c00ffd100" .. EJ_GetEncounterInfo(encounterID) .."|r") end)
							list_entries[id]:SetScript("OnEnter", function(self) list_entries[id].text:SetText("|c00ffd100" .. LBP_DB[instanceID][encounterID][id]["Name"] .."|r") end)
							list_entries[id]:SetScript("OnLeave", 
								function(self) 
									if id ~= edit_ID then
										-- list_entries[id].text:SetText("|c00ffffff" .. EJ_GetEncounterInfo(encounterID) .."|r") 
										list_entries[id].text:SetText("|c00ffffff" .. LBP_DB[instanceID][encounterID][id]["Name"] .."|r") 
									end
								end
							)
							
							list_entries[id]:SetScript("OnMouseUp", 
								function(self) 
									edit_instanceID = instanceID;
									edit_encounterID = encounterID;
									edit_ID = id;
									
									anker:Build()
								end
							)
						end	
						--list_entries[id]:Hide()
						--list_entries[id]:ClearAllPoints()
					end
					
					--end
					
				end
			end
		end
		
		
		-- hide all
		
		for index, value in pairs(list_entries) do
			list_entries[index]:ClearAllPoints()
			list_entries[index]:Hide()
		end
		
		
		
		
		for instanceID,value in pairs(LBP_DB) do
			if tonumber(instanceID) then
				
				tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 15)
				--textbox = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormal", "TOP", tmpframe, "TOP", 0, 0, 280, 20, "LEFT", "TOP", 1, 1, 1, 1)
				--textbox:SetText("|c00aaaaaa"..zone.."|r")
				
				list_entries["i"..instanceID]:ClearAllPoints()
				list_entries["i"..instanceID]:SetPoint("TOP", tmpframe, "TOP", 0, 0)
				list_entries["i"..instanceID]:Show()
				
				list:SetHeight(list:GetHeight()+textbox:GetHeight())
				
				index = 1
				
				EJ_SelectInstance(instanceID)
				
				while EJ_GetEncounterInfoByIndex(index, instanceID) do
					-- for encounterID,value in pairs(LBP_DB[instanceID]) do
					
					local name, description, encounterID = EJ_GetEncounterInfoByIndex(index, instanceID)
					
					
					--for encounterID,value in pairs(LBP_DB[instanceID]) do
					if LBP_DB[instanceID][encounterID] then
						
						tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 15)
						
						list_entries["e"..encounterID]:ClearAllPoints()
						list_entries["e"..encounterID]:SetPoint("TOP", tmpframe, "TOP", 10, 0)
						list_entries["e"..encounterID]:Show()		
						
						
						for id, listcard in pairs(LBP_DB[instanceID][encounterID]) do
							list_entries[id]:SetPoint("TOP", tmpframe, "BOTTOM", 0, 0)
							list_entries[id]:Show()
							
							
							tmpframe = LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 25)
							--LBP:CreateFrame("frame", "test", list, nil, "TOP", tmpframe, "BOTTOM", 0, 0, 280, 30)
							--list_entries[id] = LBP:CreateFontString(list, "textbox","ARTWORK", "GameFontNormalLarge", "TOP", tmpframe, "TOP", 0, 0, 280, 30, "LEFT", "TOP", 1, 1, 1, 1)
							
							
							if id == edit_ID then
								-- list_entries[id].text:SetText("|c00ffd100" .. EJ_GetEncounterInfo(encounterID) .."|r")
								list_entries[id].text:SetText("|c00ffd100" .. LBP_DB[instanceID][encounterID][id]["Name"] .."|r")
								else
								-- list_entries[id].text:SetText("|c00ffffff" .. EJ_GetEncounterInfo(encounterID) .."|r")
								list_entries[id].text:SetText("|c00ffffff" .. LBP_DB[instanceID][encounterID][id]["Name"] .."|r")
								--tmpframe:SetScript("OnEnter", function(self) list_entries[id]:SetText("|c00ffd100    " .. listcard["Name"].."|r") end)
								--tmpframe:SetScript("OnLeave", function(self) list_entries[id]:SetText("|c00ffffff    " .. listcard["Name"].."|r") end)
								--tmpframe:SetScript("OnMouseUp", function(self) 				edit_instanceID = zone;
								--edit_encounterID = subzone;
								--edit_ID = id;
								--			
								--frame:Build()
								--end)
							end
							
							list:SetHeight(list:GetHeight()+tmpframe:GetHeight())
							
						end
					end
					
					index = index+1
				end
			end
		end
		
		-- Set EJ to last tier
		EJ_SelectTier(EJ_GetNumTiers())
		
		
		
		
		
		
		if edit_ID then
			local card = deepcopy(LBP_DB[edit_instanceID][edit_encounterID][edit_ID]);
			
			
			--local specid, spec, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
			local _, specname, _, specicon = GetSpecializationInfoByID(LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Spec"]);
			
			editcard.editname:SetText(LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Name"])
			editcard.editname:SetScript("OnTextChanged",
				function (self)
					LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Name"] = editcard.editname:GetText()
					anker:Build()
				end
			)
			
			
			editcard.tb_zone:SetText(EJ_GetInstanceInfo(edit_instanceID))
			editcard.tb_subzone:SetText(EJ_GetEncounterInfo(edit_encounterID))
			
			
			
			tab.textbox:SetText(EJ_GetInstanceInfo(edit_instanceID) .."\n" .. EJ_GetEncounterInfo(edit_encounterID))
			
			
			editcard.tb_spec:SetText(specname);
			
			editcard.SpecIcon:SetTexture(specicon);		
			
			
			-- Talents
			for a = 1,7 do
				for b = 0,2 do
					s = tonumber(string.sub(card["Talents"],a,a));
					
					if b==s then
						editcard.Talents[(a-1)*3+b+1].texture:SetDesaturated(false);
						editcard.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
						editcard.Talents[(a-1)*3+b+1]:SetHeight(32)
						editcard.Talents[(a-1)*3+b+1]:SetWidth(32)
						
						editcard.Talents[(a-1)*3+b+1]:SetScript("OnMouseUp", function() LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Talents"] = string.sub(card["Talents"],1,a-1).."3"..string.sub(card["Talents"],a+1,6); anker:Build() end)
						else
						editcard.Talents[(a-1)*3+b+1].texture:SetDesaturated(true);
						editcard.Talents[(a-1)*3+b+1]:SetHeight(24)
						editcard.Talents[(a-1)*3+b+1]:SetWidth(24)
						
						editcard.Talents[(a-1)*3+b+1]:SetScript("OnMouseUp", function() LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Talents"] = string.sub(card["Talents"],1,a-1)..b..string.sub(card["Talents"],a+1,6); anker:Build() end)
					end
				end
			end
			
			
			-- Glpyhs
			
			local glyphtable = LBP:GetGlyphTable(); -- get the current glphs
			local copy = deepcopy(card["Glyphs"])
			
			for slot, value in pairs(glyphtable) do
				local glyphtype = value[1]
				
				editcard.Glyph[slot]:SetGlyph("Interface/PaperDoll/UI-Backpack-EmptySlot", true)
				editcard.Glyph[slot]:SetScript("OnEnter", nil)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				
				editcard.Glyph[slot]:SetScript("OnMouseUp", 
					function(self) 
						local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
						
						glyphlist_rahmen:Build("Interface/PaperDoll/UI-Backpack-EmptySlot", value[1])
						glyphlist_rahmen:ClearAllPoints()
						glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
						
						if relativeTo == editcard.Glyph[slot] then
							glyphlist_rahmen:Toggle()
							else
							glyphlist_rahmen:Show()
						end
					end
				)
				
				for icon, glyphid in pairs(copy[tostring(glyphtype)]) do
					editcard.Glyph[slot]:SetGlyph(icon, true)
					editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
					
					
					
					editcard.Glyph[slot]:SetScript("OnMouseUp", 
						function(self) 
							local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
							
							glyphlist_rahmen:Build(icon, value[1])
							glyphlist_rahmen:ClearAllPoints()
							glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
							
							if relativeTo == editcard.Glyph[slot] then
								glyphlist_rahmen:Toggle()
								else
								glyphlist_rahmen:Show()
							end
						end
					)
					
					copy[tostring(glyphtype)][icon] = nil;
					break
				end
			end
			
			
			--[[
				for slot,value in pairs(glyphtable) do
				editcard.Glyph[slot]:SetGlyph("Interface/ICONS/INV_MISC_QUESTIONMARK", true)
				
				local glyphtype = value[1];
				local icon = value[2];
				
				
				for index, glyphid in pairs(copy[tostring(glyphtype)]) do
				
				if icon == index then
				editcard.Glyph[slot]:SetGlyph(icon, true)
				editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				glyphtable[slot] = nil;
				copy[tostring(glyphtype)][index] = nil;
				end
				end		
				editcard.Glyph[slot]:SetScript("OnMouseUp", function(self) 
				local point, relativeTo, relativePoint, xOffset, yOffset = glyphlist_rahmen:GetPoint(1)
				
				glyphlist_rahmen:Build(icon, value[1])
				glyphlist_rahmen:ClearAllPoints()
				glyphlist_rahmen:SetPoint("LEFT", editcard.Glyph[slot], "RIGHT")
				
				if relativeTo == editcard.Glyph[slot] then
				glyphlist_rahmen:Toggle()
				else
				glyphlist_rahmen:Show()
				end
				end)
				end
				
				for slot, value in pairs(glyphtable) do
				local glyphtype = value[1]
				for icon, glyphid in pairs(copy[tostring(glyphtype)]) do
				editcard.Glyph[slot]:SetGlyph(icon, false)
				editcard.Glyph[slot]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.Glyph[slot]); GameTooltip:SetGlyphByID(glyphid); GameTooltip:Show(); end)
				editcard.Glyph[slot]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				copy[tostring(glyphtype)][icon] = nil;
				break
				end
				end
			--]]		
			
			
			-- Macros
			if not card["Macro1"] then card["Macro1"] = "/script print(\"LBP: Macro #1\")"; end
			if not card["Macro2"] then card["Macro2"] = "/script print(\"LBP: Macro #2\")"; end
			if not card["Macro3"] then card["Macro3"] = "/script print(\"LBP: Macro #3\")"; end
			if not card["Macro4"] then card["Macro4"] = "/script print(\"LBP: Macro #4\")"; end
			
			--[[
				local name, iconTexture, body = GetMacroInfo("LBP Macro 3");
				editcard.macroframe3:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
				editcard.macroframe3:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe3); GameTooltip:SetText(card["Macro3"]); GameTooltip:Show(); end)
				editcard.macroframe3:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				
				local name, iconTexture, body = GetMacroInfo("LBP Macro 4");
				editcard.macroframe4:SetBackdrop({bgFile = iconTexture, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
				editcard.macroframe4:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe4); GameTooltip:SetText(card["Macro4"]); GameTooltip:Show(); end)
				editcard.macroframe4:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)		
				
				
			--]]
			
			for a = 1,4 do 
				
				editcard.editbox_macro_editbox[a]:SetScript("OnTextChanged", function (self) end )		
				editcard.editbox_macro_editbox[a]:SetText(LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Macro"..a])
				editcard.editbox_macro_editbox[a]:SetScript("OnTextChanged",
					function (self)
						LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Macro"..a] = editcard.editbox_macro_editbox[a]:GetText() EditMacro(GetMacroIndexByName("LBP Macro "..a),"LBP Macro "..a,nil, editcard.editbox_macro_editbox[a]:GetText())
						
						local name, iconTexture, body = GetMacroInfo("LBP Macro "..a);
						editcard.macroframe[a]:SetBackdrop({bgFile = iconTexture})--, tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
						editcard.macroframe[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(editcard.macroframe[a]); GameTooltip:SetText(editcard.editbox_macro_editbox[a]:GetText()); GameTooltip:Show(); end)
						editcard.macroframe[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					end
				)
				editcard.editbox_macro[a]:UpdateScrollChildRect()
				editcard.editbox_macro_editbox[a]:SetCursorPosition(0)
				editcard.editbox_macro[a]:SetVerticalScroll(0)
				
				
				
				editcard.button_m[a].text = LBP_DB[edit_instanceID][edit_encounterID][edit_ID]["Macro"..a];
				editcard.button_m[a]:SetScript("OnClick", 
					function(self) 
						editcard.editbox_macro_editbox[a]:SetText(editcard.button_m[a].text)
					end
				)
				
				
				
			end
		end
		
		
		
		
		
		
		if edit_ID then
			tab:Show()
			else	
			tab:Hide()
		end
		
		return
		
		end
		
		
		
		
		
		anker:Build()
		
		tab:Hide()
		anker:Hide()
		
		return anker
	end
	
	
	
	
	
	
	
